---

- name: Create temporary directory for configuration fragments
  tempfile:
    state: directory
    suffix: temp
  register: config_fragments
  # we only care about the final assembled changed status
  changed_when: False

- name: Generate config header
  # noqa risky-file-permissions
  template:
    src: sw_header.conf
    dest: "{{ config_fragments.path }}/0_header"
  # we only care about the final assembled changed status
  changed_when: False

- name: Generate config core
  # noqa risky-file-permissions
  template:
    src: sw.conf
    dest: "{{ config_fragments.path }}/1_core"
    newline_sequence: '\r\n'
  # we only care about the final assembled changed status
  changed_when: False

- name: Fetch config core content
  slurp:
    src: "{{ config_fragments.path }}/1_core"
  register: file

- name: Compute config core CRC
  set_fact:
    config_crc: "{{ file['content'] | crc32hex | replace('0x', '') | upper }}"

- name: Generate config footer
  # noqa risky-file-permissions
  template:
    src: sw_footer.conf
    dest: "{{ config_fragments.path }}/2_footer"
  # we only care about the final assembled changed status
  changed_when: False

- name: Generate final config
  # noqa risky-file-permissions
  assemble:
    src: "{{ config_fragments.path }}"
    dest: "{{ output }}"

- name: Remove temporary directory for config fragments
  file:
    path: "{{ config_fragments.path }}"
    state: absent
  # we only care about the final assembled changed status
  changed_when: False

